﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using Infragistics.Win;

namespace WS_CalendarComboWithMask
{
    class CustomDataFilter : IEditorDataFilter
    {
        #region Fields
        private string mask = null;
        private IFormatProvider provider = null;
        #endregion // Fields

        #region Constructors
        public CustomDataFilter(string mask)
        {
            this.mask = mask;
        }

        public CustomDataFilter(string mask, IFormatProvider provider)
        {
            this.mask = mask;
            this.provider = provider;
        }
        #endregion // Constructors

        #region Properties
        public string Mask
        {
            get { return mask; }
            set { mask = value; }
        }

        public IFormatProvider Provider
        {
            get { return provider; }
            set { provider = value; }
        }
        #endregion // Properties

        #region IEditorDataFilter Implementation
        public object Convert(EditorDataFilterConvertArgs conversionArgs)
        {

            if (conversionArgs.Direction == ConversionDirection.EditorToDisplay)
            {
                var value = conversionArgs.Value;

                if (value != null && value.GetType() == typeof(DateTime))
                {
                    conversionArgs.Handled = true;
                    DateTime date = (DateTime)conversionArgs.Value;
                    if (provider != null)
                        return date.ToString(mask, provider);
                    else
                        return date.ToString(mask);
                }
            }

            return conversionArgs.Value;
        }
        #endregion // IEditorDataFilter Implementation

    }
}
